from typing import TYPE_CHECKING

from sqlalchemy import Column, ForeignKey, Integer, String, Enum
from sqlalchemy.orm import relationship

from app.db.base_class import Base

import enum

if TYPE_CHECKING:
    from .user import User  # noqa: F401

class Progress(enum.Enum):
  WAITING = enum.auto()
  PROCESSING = enum.auto()
  COMPLETE = enum.auto()

class Video(Base):
  id = Column(Integer, primary_key=True, index=True)
  title = Column(String, index=True)
  progress = Column(Enum(Progress))
  owner_id = Column(Integer, ForeignKey("user.id"))
  owner = relationship("User", back_populates="videos")